package net.inzynierr.malware_remover;

import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;

public class MalwareClassVisitor extends ClassVisitor {

  private boolean canModify;

  public MalwareClassVisitor(ClassWriter writer) {
    super(Opcodes.ASM9, writer);
  }

  @Override
  public MethodVisitor visitMethod(int access, String name, String descriptor, String signature,
      String[] exceptions) {
    return name.equals("onEnable") && this.canModify ? new MalwareMethodVisitor(
        super.visitMethod(access, name, descriptor, signature, exceptions))
        : super.visitMethod(access, name, descriptor, signature, exceptions);
  }

  @Override
  public void visit(int version, int access, String name, String signature, String superName,
      String[] interfaces) {
    this.canModify = superName != null && superName.equals("org/bukkit/plugin/java/JavaPlugin");
    super.visit(version, access, name, signature, superName, interfaces);
  }
}
